--
-- cableConnector
-- Specialization for cableConnector
--
-- @author upsidedown
-- @date  15.07.2013
--


cableConnector = {};

function cableConnector.prerequisitesPresent(specializations)
    return true;--SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function cableConnector:load(xmlFile)

	
	self.cableConnectors = {};
    local i=0;
    while true do
        local areaKey = string.format("vehicle.cableConnectors.cableConnector(%d)", i);
        if not hasXMLProperty(xmlFile, areaKey) then
            break;
        end

        local connector = {};
		connector.Visible = getXMLString(xmlFile, areaKey .. "#indexVisible")

		if connector.Visible~= nil then
			connector.Visible = Utils.indexToObject(self.components, connector.Visible);
		end;

		connector.NotVisible = getXMLString(xmlFile, areaKey .. "#indexNotVisible")
		if connector.NotVisible~= nil then
			connector.NotVisible = Utils.indexToObject(self.components, connector.NotVisible);
		end;

		connector.start = Utils.indexToObject(self.components, getXMLString(xmlFile, areaKey .. "#startIndex"));
		connector.turn1 = Utils.indexToObject(self.components, getXMLString(xmlFile, areaKey .. "#turnIndex1"));
		connector.turn2 = Utils.indexToObject(self.components, getXMLString(xmlFile, areaKey .. "#turnIndex2"));
		
		
		connector.truckSide = Utils.indexToObject(self.components, getXMLString(xmlFile, areaKey .. "#truckSideIndex"));	
		connector.truckBox = Utils.indexToObject(self.components, getXMLString(xmlFile, areaKey .. "#truckBoxIndex"));	

		
		connector.truckBoxY = Utils.getNoNil(getXMLFloat(xmlFile, areaKey .. "#truckBoxY"),0);
		connector.truckBoxZ = Utils.getNoNil(getXMLFloat(xmlFile, areaKey .. "#truckBoxZ"),0);

		
        i = i + 1;
		self.cableConnectors[i] = connector;		
    end
	
	self.cableConnectorIsAttached = false;
	
	for _,connector in pairs(self.cableConnectors) do
		if connector.Visible ~= nil then
			setVisibility(connector.Visible,false);
		end;
		
		if connector.NotVisible ~= nil then
			setVisibility(connector.NotVisible,true);
		end;
		
		if connector.truckBox ~= nil then
			setVisibility(connector.truckBox,false);
		end;
		
	end;
	
end;

function cableConnector:update(dt)
	
	
	if self.attacherVehicle~= nil then
		
       
		if true then --self.attacherVehicle.cableAttacherNode ~= nil then
			for k,connector in pairs(self.cableConnectors) do
			
				if self.attacherVehicle.cableAttacherNode == nil then
					self.attacherVehicle.cableAttacherNode = {};
				end;
				if not self.cableConnectorIsAttached then--self.attacherVehicle.cableAttacherNode[k] == nil then
					local implementIndex = self.attacherVehicle:getImplementIndexByObject(self);
					local implement = self.attacherVehicle.attachedImplements[implementIndex];
					local jointDescIndex = implement.jointDescIndex;
					if self.attacherVehicle.cableAttacherNode[k] == nil then
						self.attacherVehicle.cableAttacherNode[k] = createTransformGroup("Attacher_Cable"); 
					end;
					link(self.attacherVehicle.attacherJoints[jointDescIndex].jointTransform,self.attacherVehicle.cableAttacherNode[k]);
					
					setRotation(self.attacherVehicle.cableAttacherNode[k],0,-math.pi/2,0)

					setTranslation(self.attacherVehicle.cableAttacherNode[k],connector.truckBoxZ,connector.truckBoxY,0);
					
					

					link(self.attacherVehicle.cableAttacherNode[k],connector.truckSide)
					link(self.attacherVehicle.cableAttacherNode[k],connector.truckBox)
				end;
				
				local dx1,dy1,dz1 = localDirectionToWorld(self.attacherVehicle.cableAttacherNode[k], 0, 0, 1)
				local dx2,dy2,dz2 = worldDirectionToLocal(connector.start,dx1,dy1,dz1)
				
				local yRot = Utils.getYRotationFromDirection(dx2, dz2)
				--print(tostring(k) .. "  " .. tostring(yRot))
				--yRot = math.pi;
				
				if k == 1 then
					yRot = yRot * 2.5;
				end;
				local rx,ry,rz = getRotation(connector.turn1);
				setRotation(connector.turn1,rx,yRot,rz);
				if k == 1 then
					yRot = -2.5*yRot;
				end;
				rx,ry,rz = getRotation(connector.turn2);
				setRotation(connector.turn2,rx,yRot*.66,rz);
				
			end;
		end;
		self.cableConnectorIsAttached = true;
	end;
end;

function cableConnector:updateTick(dt)	
        
end;


function cableConnector:delete()
end;

function cableConnector:mouseEvent(posX, posY, isDown, isUp, button)
end;

function cableConnector:keyEvent(unicode, sym, modifier, isDown)
end;

function cableConnector:draw()
end;

function cableConnector:onAttach()
	for _,connector in pairs(self.cableConnectors) do
		
		
		if connector.Visible ~= nil then
			setVisibility(connector.Visible,true);			
		end;
		
		if connector.truckBox ~= nil then
			setVisibility(connector.truckBox,true);
		end;		
		
		if connector.NotVisible ~= nil then
			setVisibility(connector.NotVisible,false);
		end;
	end;
end; 	

function cableConnector:onDetach()
	-- for k,attacherNode in pairs(self.attacherVehicle.cableAttacherNode) do
		-- delete(self.attacherVehicle.cableAttacherNode[k]);
	-- end
	
	-- self.attacherVehicle.cableAttacherNode = nil;

	self.cableConnectorIsAttached = false;
	
	
	
	
	for _,connector in pairs(self.cableConnectors) do
		if connector.Visible ~= nil then
			setVisibility(connector.Visible,false);
		end;
		
		if connector.NotVisible ~= nil then
			setVisibility(connector.NotVisible,true);
		end;
		
		if connector.truckBox ~= nil then
			setVisibility(connector.truckBox,false);
		end;
		link(self.rootNode,connector.truckSide)
		link(self.rootNode,connector.truckBox)
		
	end;
end;