--
-- doppelHebel
-- Specialization for doppelHebel
--
-- @author upsidedown
-- @date  31.07.2013


doppelHebel = {};

function doppelHebel.prerequisitesPresent(specializations)
    return true; 
end;

function doppelHebel:load(xmlFile)
		self.doppelHebel = {}
		self.doppelHebel.followNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.doppelHebel#followIndex"));
		self.doppelHebel.mitteNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.doppelHebel#mitteIndex"));
		self.doppelHebel.mitteRef1Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.doppelHebel#mitteRef1Index"));
		self.doppelHebel.mitteRef2Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.doppelHebel#mitteRef2Index"));
		self.doppelHebel.endNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.doppelHebel#endIndex"));
		self.doppelHebel.linkNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.doppelHebel#linkIndex1"));
		self.doppelHebel.linkNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.doppelHebel#linkIndex2"));
		
		local x1,y1,z1 = getWorldTranslation(self.doppelHebel.linkNode1);
		local x2,y2,z2 = getWorldTranslation(self.doppelHebel.mitteRef1Node);
		self.doppelHebel.distance1 = Utils.vector2Length(y1-y2,z1-z2);
		--print("distance 1: " .. tostring(self.doppelHebel.distance1))
		
		x1,y1,z1 = getWorldTranslation(self.doppelHebel.linkNode2);
		x2,y2,z2 = getWorldTranslation(self.doppelHebel.mitteRef2Node);
		self.doppelHebel.distance2 = Utils.vector3Length(x1-x2,y1-y2,z1-z2) -0.01 --0.015;-- .007;
		self.doppelHebel.distance2_0 = self.doppelHebel.distance2;
		--self.doppelHebel.distance2 = 3.2
		--print("distance 2: " .. tostring(self.doppelHebel.distance2))
		
		self.doppelHebel.playerInRange = false;
		self.ladderDown = false;
end;

function doppelHebel:update(dt)
	if self.doppelHebel.playerInRange then
		if InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
			self.ladderDown = not self.ladderDown;
			if g_server ~= nil then
				g_server:broadcastEvent(Ladder_Event:new(self, self.ladderDown), nil, nil, self);
			else
				g_client:getServerConnection():sendEvent(Ladder_Event:new(self, self.ladderDown));
			end;
			
			
			for anim = 2,7,1 do
				self:toggle(anim,not self.animParts[anim].toMax);
			end
			
		end;
		g_currentMission:addHelpButtonText(g_i18n:getText("Leiter"), InputBinding.LOWER_IMPLEMENT);
	end;

	if self:getIsActive() or true then
		local followHasMoved = false;
		
		followHasMoved = true; --implement check for performance later!
	
		local x1,y1,z1 = getWorldTranslation(self.doppelHebel.linkNode1);
		local x2,y2,z2 = getWorldTranslation(self.doppelHebel.mitteRef1Node);
		local distance = Utils.vector3Length(x1-x2,y1-y2,z1-z2);
		local lastDistance = distance;
		local direction = 1.0;
		local cnt = 0;
		local rx,ry,rz = getRotation(self.doppelHebel.mitteNode);
		while math.abs(distance - self.doppelHebel.distance1) > .001 do
			
			rx = rx - direction*0.2*(distance - self.doppelHebel.distance1)
			setRotation(self.doppelHebel.mitteNode,rx,ry,rz)
		    x2,y2,z2 = getWorldTranslation(self.doppelHebel.mitteRef1Node);
		    distance = Utils.vector3Length(x1-x2,y1-y2,z1-z2);
			
			if distance^2 > lastDistance^2 then
				direction = direction;
			end;
			lastDistance = distance;
			
			cnt = cnt + 1;
			if cnt > 20 then
				--print("error: no convergence for doppelHebel 1")
				break;
			end;
			--print(cnt)
		end
		
		----------------rot ladder
		cnt = 0;		
		x1,y1,z1 = getWorldTranslation(self.doppelHebel.linkNode2);
		x2,y2,z2 = getWorldTranslation(self.doppelHebel.mitteRef2Node);
		distance = Utils.vector3Length(x1-x2,y1-y2,z1-z2);
		rx,ry,rz = getRotation(self.doppelHebel.endNode);
		lastDistance = distance;
		direction = 1.0;
		local tmp = 0.02;
		while math.abs(distance - self.doppelHebel.distance2) > .002 do			
			rx = rx + direction*0.1*(distance - self.doppelHebel.distance2)
			rx = math.min(rx,math.rad(0));
			rx = math.max(rx,math.rad(-179));
			
			self.doppelHebel.distance2 = self.doppelHebel.distance2_0 - math.deg(rx)/180*0.015
			
			--print(math.deg(rx))
			setRotation(self.doppelHebel.endNode,rx,ry,rz)
		    x1,y1,z1 = getWorldTranslation(self.doppelHebel.linkNode2);
		    distance = Utils.vector3Length(x1-x2,y1-y2,z1-z2);
			-----------------print(cnt)
			--print(distance)
			if distance^2 > lastDistance^2 then
				direction = direction;
			end;
			lastDistance = distance;
			--print(tostring(distance).."   "..tostring(self.doppelHebel.distance2-(rx%(2*math.pi))*tmp))
			--renderText(.5,.5,.05,tostring(distance).."   "..tostring(self.doppelHebel.distance2-(rx%(2*math.pi))*0.1))
			cnt = cnt + 1;
			if cnt > 25 then
				--print("error: no convergence for doppelHebel 2")
				break;
			end;			
		end
		
		------------------rot 1st link		
		x1,y1,z1 = getWorldTranslation(self.doppelHebel.mitteRef1Node)
		x1,y1,z1 = worldToLocal(self.doppelHebel.linkNode1,x1,y1,z1)
		local angle = Utils.getYRotationFromDirection(z1,y1)-math.pi+math.rad(6.7);
		rx,ry,rz = getRotation(self.doppelHebel.linkNode1);
		rx = rx + angle;
		setRotation(self.doppelHebel.linkNode1,rx,ry,rz)
		
		
		---------------------------------rot 2nd link
		x1,y1,z1 = getWorldTranslation(self.doppelHebel.mitteRef2Node)
		x1,y1,z1 = worldToLocal(self.doppelHebel.linkNode2,x1,y1,z1)
		angle = Utils.getYRotationFromDirection(z1,y1)-math.pi/2;
		rx,ry,rz = getRotation(self.doppelHebel.linkNode2);
		rx = rx + angle;
		setRotation(self.doppelHebel.linkNode2,rx,ry,rz)
	end;

	
end;

function doppelHebel:updateTick(dt)	
	self.doppelHebel.playerInRange = false;
	if g_currentMission.controlledVehicle == nil then --player on foot
		if g_currentMission.player ~= nil then
			local pvx, pvy, pvz = getWorldTranslation(g_currentMission.player.rootNode);
			local x, y, z = getWorldTranslation(self.doppelHebel.endNode);
			local farmerDistance = Utils.vector3Length(pvx-x, pvy-y, pvz-z);
			
			if farmerDistance < 3  then
				self.doppelHebel.playerInRange = true;
			end;
		end;
	end;	
end;

function doppelHebel:delete()
end;

function doppelHebel:mouseEvent(posX, posY, isDown, isUp, button)
end;

function doppelHebel:keyEvent(unicode, sym, modifier, isDown)
end;

function doppelHebel:draw()
	
end;

function doppelHebel:onAttach()
end; 	

function doppelHebel:onDetach()
end;


function doppelHebel:writeStream(streamId, connection)
    streamWriteBool(streamId, self.ladderDown);
	

end;


function doppelHebel:readStream(streamId, connection)
    self.ladderDown = streamReadBool(streamId);
end;





  
  Ladder_Event = {};
  Ladder_Event_mt = Class(Ladder_Event, Event);
  
  InitEventClass(Ladder_Event, "Ladder_Event");
  
  function Ladder_Event:emptyNew()
      local self = Event:new(Ladder_Event_mt);
      return self;
  end;
  
  function Ladder_Event:new(object, data)
      local self = Ladder_Event:emptyNew()
      self.data = data;
	  
      self.object = object;
      return self;
  end;
  
  function Ladder_Event:readStream(streamId, connection)
      local id = streamReadInt32(streamId);
      self.data = streamReadBool(streamId);
      
	  
	  self.object = networkGetObject(id);
      self:run(connection);
  end;
  
  function Ladder_Event:writeStream(streamId, connection)
      streamWriteInt32(streamId, networkGetObjectId(self.object));
	  streamWriteBool(streamId, self.data);

  end;
  
  function Ladder_Event:run(connection)
	  self.object.ladderDown = self.data;
	 
      if not connection:getIsServer() then
          g_server:broadcastEvent(Ladder_Event:new(self.object, self.data), nil, connection, self.object);
      end;
  end;