--
-- manometer
-- Specialization for manometer
--
-- @author upsidedown
-- @date  13.07.2013


manometer = {};

function manometer.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function manometer:load(xmlFile)
		self.manometerNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.manometer#index"));
		self.manometerMin = Utils.getNoNil(getXMLFloat(xmlFile,"vehicle.manometer#min"), 0)
		self.manometerMax = Utils.getNoNil(getXMLFloat(xmlFile,"vehicle.manometer#max"), 180)
		
		
		
end;

function manometer:update(dt)
		
end;

function manometer:updateTick(dt)	
    local bar = 0;
	
	if self.attacherVehicle == nil then
		bar = 0;
	else
		bar = 7.5;
		if self.hoseConnectorHUDselect == 4 then
			bar = 6.7
			bar = bar + (math.random()-0.5)
		end;
		
	end;
	local angle = bar/16.0*(self.manometerMax - self.manometerMin) + self.manometerMin
	setRotation(self.manometerNode,math.rad(angle),0,0)
end;

function manometer:delete()
end;

function manometer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function manometer:keyEvent(unicode, sym, modifier, isDown)
end;

function manometer:draw()
end;

function manometer:onAttach()
end; 	

function manometer:onDetach()
end;